:-  module(mathematica_link, [evaluate/2,mathematica_close_link/0], [foreign_interface]).

:- doc(author, "Maximiliano Klemen").
:- doc(author, "Remy Haemmerle").

:- doc(title, "Simple Interface to Mathematica").
:- doc(module, 
	"This library allows connecting a Ciao Prolog application with
	Mathematica 9."
      ).

:- true pred mathematica_init(in(Kernel),go(Status)) :: (atm*int) + (foreign(mathematica_init), returns(Status)).

:- true pred evaluateInMathematica(in(Query), go(Result)) :: (string * string) + (foreign(evaluateInMathematica), returns(Result)).

:- true pred mathematica_close_link + (foreign(closelink)).
 
:- pred evaluate(Query, Result) # "Sends the expression @var{Query} to Mathematica and returns the response in @var{Result}".
evaluate(Query,Result):-
	    mathematica_link_path(Kernel),
	    (
		(mathematica_init(Kernel,S),S=0) -> 
		evaluateInMathematica(Query,Result)
	    ;
		error_code(S,E),
		throw(error(E, evaluate/2))
	    ).
	
error_code(1,mathematica_initialization).
error_code(2,mathematica_opening_link).
error_code(3,mathematica_broken_link).

:- use_foreign_source(library(mathematica/mathematica_conn)).
:- include(library(mathematica/mathematica_decl_auto)).




