:- module(_, _, [regtypes, fsyntax, assertions]).

:- include(lpdoclib('SETTINGS_schema')).
% ****************************************************************************
% This is an LPdoc configuration file. See SETTINGS_schema for documentation *
% ****************************************************************************

:- use_module(library(bundletool/paths_extra), [fsR/2]).

:- reexport(ciao_docsrc(common/'LPDOCCOMMON')).
libtexinfo(_) :- fail.
datamode(_) :- fail.
execmode(_) :- fail.

% (not customized)
bibfile(_) :- fail.
htmldir(_) :- fail.
docdir(_) :- fail.
infodir(_) :- fail.
mandir(_) :- fail.

output_name := 'bundletool'.

% TODO: use parent_bundle to share those defs
filepath := ~fsR(bundle_src(ciao)/'doc'/'bundletool'). % TODO: really?
filepath := ~ciaofilepath_common.

doc_structure := 
        'bundletool_reference'-[
          % TODO: Missing lib/bundle/* modules
	  % TODO: Missing hooks for bundleconfig and bundlehooks
          'bundletool/bundletool_aux',
          'bundletool/bundlehooks_holder',
          'bundletool/bundle_configure',
          'bundletool/detcheader',
	  %
          'bundletool/info_installer',
          'bundletool/register_in_script',
	  %
          'bundletool/bundle_actions_aux',
          'bundletool/ciaoc_aux',
          'bundletool/bundle_aux',
          'bundletool/bundle_params',
          'bundletool/pbundle_generator'-[
            'bundletool/pbundle_meta',
            'bundletool/pbundle_gen_common',
            'bundletool/pbundle_gen_bin',
            'bundletool/pbundle_gen_mac',
            'bundletool/pbundle_gen_rpm',
            'bundletool/pbundle_gen_src',
            'bundletool/pbundle_gen_win32'
          ],
          'bundletool/messages_aux',
          'bundletool/interactive_aux'
        ].

%doc_mainopts := no_patches.
doc_mainopts := _ :- fail. % Allow patches in main changelog (those are the release notes)

% TODO: Added no_propuses because texindex breaks with very large
%       indices (due to internal, maybe arbitrary, limitations) --JF.
doc_compopts := no_isoline|no_engmods|propmods|no_changelog|no_propuses.


