/*
 *  own_malloc.c
 *
 *  New memory manager.
 *
 *  Copyright (C) 1996,1997,1998, 1999, 2000, 2001, 2002 UPM-CLIP
 *
 *  Author:
 *    Manuel Carro
 */

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#if !defined(Win32i86)
# include <strings.h>
#endif

#if defined(DEBUG)
#include <stdio.h>
#endif

#include "configure.h"
#include "termdefs.h"
#include "debug.h"

#include "own_mmap.h"
#include "own_malloc.h"

#if defined(USE_OWN_MALLOC)

#define ALIGN sizeof(tagged_t)       /* blocks suitably aligned for any use */
#define TW_TO_CHARS(Tw) (Tw)*ALIGN
#define CHARS_TO_TW(Chars) ((Chars)%ALIGN==0 ? (Chars)/ALIGN : (Chars)/ALIGN+1)

static int min_mem_alloc = MIN_MEM_ALLOC; /* Shared, locked */

// #include "own_malloc_linear.h"
#include "own_malloc_bin.h"

#endif /* USE_OWN_MALLOC */
