/*
 *  streams.h
 *
 *  Stream handling primitives.
 *
 *  Copyright (C) 1996,1997,1998, 1999, 2000, 2001, 2002 UPM-CLIP
 */

#ifndef _CIAO_STREAMS_H
#define _CIAO_STREAMS_H

/* Streams pointing to "user" -- should be shared */

extern stream_node_t *stream_user_input;                   /* Shared */
extern stream_node_t *stream_user_output;                  /* Shared */
extern stream_node_t *stream_user_error;                   /* Shared */


/* root of the stream pointers -- shared */

extern stream_node_t *root_stream_ptr;            /* Shared & locked */

/* initialization */

void init_streams(void);

/* operations on streams */

stream_node_t *insert_new_stream(stream_node_t *new_stream);
void update_stream(register stream_node_t *s, FILE *file);

CFUN__PROTO_N(ptr_to_stream_noalias, tagged_t, register stream_node_t *n);
CFUN__PROTO_N(ptr_to_stream, tagged_t, register stream_node_t *n);

/* stream predicates */

CBOOL__PROTO(prolog_bootversion);
CBOOL__PROTO(prolog_sourcepath);
CBOOL__PROTO(prolog_open);
CBOOL__PROTO(prolog_close);
CBOOL__PROTO(prolog_unix_popen);
void ENG_perror(char *s);
CBOOL__PROTO(prolog_current_input);
CBOOL__PROTO(prolog_set_input);
CBOOL__PROTO(prolog_current_output);
CBOOL__PROTO(prolog_set_output);
CBOOL__PROTO(prolog_get_stream);
CBOOL__PROTO(prolog_replace_stream);
CBOOL__PROTO(prolog_stream_code);
CBOOL__PROTO(character_count);
CBOOL__PROTO(line_position);
CBOOL__PROTO(line_count);

CBOOL__PROTO(current_stream);
CBOOL__PROTO(nd_current_stream);

#endif /* _CIAO_STREAMS_H */
