#!/bin/sh
# ===========================================================================
# car_exec.sh: Running .car-style executables
#
# Author: Remy Haemmerle
# Author: Jose F. Morales (minor changes)
# ===========================================================================
#
# Usage: see library(make_car_exec) for details
#
# ---------------------------------------------------------------------------

# Exit immediately if a simple command exits with a non-zero status
set -e

# ---------------------------------------------------------------------------
# Select CIAODESRC based on the directory where this script lives

self_base_name=$(basename "$0")
self_dir=$(e=$0;while test -L "$e";do d=$(dirname "$e");e=$(readlink "$e");\
       cd "$d";done;cd "$(dirname "$e")";pwd -P)

export CIAODESRC="${self_dir}/${self_base_name}.car"

. "${CIAODESRC}/ciao/lib/compiler/scripts/clean_aux.sh"
. "${CIAODESRC}/ciao/lib/compiler/scripts/builddir_aux.sh"

CIAODESRC_PATH="${CIAODESRC}/build/CIAODESRC_PATH"

# Verifies if the executable has changed place since the last execution time.
# If yes, then reconfigure paths.
CIAODESRC_PREVIOUS=$(if test -f "${CIAODESRC_PATH}"; then  cat "${CIAODESRC_PATH}"; fi)

if [  x"${CIAODESRC_PREVIOUS}" != x"${CIAODESRC}" ]; then 
    (cd "${CIAODESRC}" && builddir_configure_boot "${CIAODESRC}/build-boot" && ./ciaosetup rescan-bundles > /dev/null)
    printf "${CIAODESRC}" > "${CIAODESRC_PATH}"
fi

export CIAOENGINE="${CIAODESRC}/build/objs/ciaoengine"
export CIAOLIB="${CIAODESRC}/ciao"

exec "${CIAODESRC}/build/bin/${self_base_name}" "$@"
