:- package(bundlehooks).

% Package for the definition of bundle hooks
:- use_package(fsyntax).
:- use_package(hiord).
:- use_package(assertions).
:- use_package(regtypes).
:- use_package(isomodes).

:- load_compilation_module(library(bundlehooks/bundlehooks_tr)).
:- add_sentence_trans(bundlehooks_tr:defdep/3, 320).

:- use_module(library(bundletool/messages_aux),
	[bold_message/1, bold_message/2, normal_message/2]).
:- use_module(library(bundletool/bundle_actions_aux)).

:- discontiguous '$bundlehook_decl'/1.
:- discontiguous '$bundlehook_do'/1.

% Hooks for bundle description
:- include(library(bundletool/bundle_actions_hookdefs)).

% Bundle configuration
:- use_module(library(bundletool/bundle_params), [bundle_param_value/3]).


