:- module(bundle_params, [
		bundle_param_value/3,
		set_bundle_param_value/3,
		add_bundle_param_value/3,
		del_bundle_param_value/2,
		root_bundle_name/1,
		normalize_param_name/2,
		toupper/2,
		tolower/2
            ],
	    [assertions, regtypes, dcg, hiord]).

:- doc(title, "Bundle Configuration Parameters").
% (input of bundle configuration)

% TODO: Find another name for this
root_bundle_name(ciaode).

:- data param_value_/3.

bundle_param_value(Bundle, Name, Value) :-
	data_facts:current_fact(param_value_(Name, Bundle, Value)).

add_bundle_param_value(Bundle, Name, Value) :-
	data_facts:assertz_fact(param_value_(Name, Bundle, Value)).

del_bundle_param_value(Bundle, Name) :-
	data_facts:retractall_fact(param_value_(Name, Bundle, _)).

set_bundle_param_value(Bundle, Name, Value) :-
	data_facts:retractall_fact(param_value_(Name, Bundle, _)),
	data_facts:asserta_fact(param_value_(Name, Bundle, Value)).

:- use_module(library(hiordlib), [map/3]).

normalize_param_name(Name, NameN) :-
	atom_codes(Name, NameC),
	map(NameC, normalizecode, NameNC),
	atom_codes(NameN, NameNC).

normalizecode --> touppercode, normunderscore.

normunderscore(0'-, 0'_) :- !.
normunderscore(C,   C).

% TODO: rename... move to bundle_config?
toupper(Name, Upper) :-
	atom_codes(Name, NameC),
	map(NameC, touppercode, UpperC),
	atom_codes(Upper, UpperC).

touppercode(C, U) :-
	0'a =< C,
	C =< 0'z,
	!,
	U is C + (0'A - 0'a).
touppercode(C, C).

% TODO: rename... move to bundle_config?
tolower(Name, Lower) :-
	atom_codes(Name, NameC),
	map(NameC, tolowercode, LowerC),
	atom_codes(Lower, LowerC).

tolowercode(C, U) :-
	0'A =< C,
	C =< 0'Z,
	!,
	U is C - 0'A + 0'a.
tolowercode(C, C).


