:- module(pbundle_gen_bin, _, [assertions, fsyntax]).

% TODO: What is a binary installer?
:- doc(title,  "pbundle Generation as Binary Installers").
:- doc(author, "Edison Mera").
:- doc(module, "This file is part of the CiaoDE installation system.").

:- use_module(library(bundletool/pbundle_gen_common)).
:- use_module(library(bundletool/pbundle_generator)).
:- use_module(library(bundle/bundle_info), [
	enum_bundle/2,
	gen_bundle_commit_info/1]).

% TODO: Offer a simpler interface (with just gen_pbundle and
%       arguments, reflecting the new options for ciaosetup)

% (hooks for gen_pbundle)
:- include(library(bundletool/pbundle_gen_hookdefs)).

% (hook)
gen_pbundle_hook(bin, Bundle, _Options) :- !,
	gen_bundle_commit_info(Bundle),
	gen_pbundle_common(Bundle, bin, [tgz, tbz]).
gen_pbundle_hook(bin_tgz, Bundle, _Options) :- !,
	gen_bundle_commit_info(Bundle),
	gen_pbundle_common(Bundle, bin, [tgz]).
gen_pbundle_hook(bin_tbz, Bundle, _Options) :- !,
	gen_bundle_commit_info(Bundle),
	gen_pbundle_common(Bundle, bin, [tbz]).
gen_pbundle_hook(noa, Bundle, _Options) :- !,
	gen_bundle_commit_info(Bundle),
	gen_pbundle_common(Bundle, noa, [tgz, tbz]).
gen_pbundle_hook(noa_tgz, Bundle, _Options) :- !,
	gen_bundle_commit_info(Bundle),
	gen_pbundle_common(Bundle, noa, [tgz]).
gen_pbundle_hook(noa_tbz, Bundle, _Options) :- !,
	gen_bundle_commit_info(Bundle),
	gen_pbundle_common(Bundle, noa, [tbz]).
