:- module(pbundle_gen_src, _, [assertions, fsyntax]).
% TODO: Export list?

:- doc(title,  "pbundle Generation as Source Tar").
:- doc(author, "Edison Mera").
:- doc(module, "This file is part of the CiaoDE installation system.").

:- use_module(library(bundletool/paths_extra), [fsR/2]).
:- use_module(library(bundle/bundle_info), [
	enum_bundle/2,
	bundle_versioned_packname/2,
	gen_bundle_commit_info/1]).
:- use_module(library(bundletool/pbundle_gen_common)).
:- use_module(library(bundletool/pbundle_generator)).

% (hooks for gen_pbundle)
:- include(library(bundletool/pbundle_gen_hookdefs)).

% (hook)
gen_pbundle_hook(src, Bundle, _Options) :- !,
	gen_bundle_commit_info(Bundle),
	gen_pbundle_common(Bundle, src, [tgz, tbz]).
gen_pbundle_hook(tgz, Bundle, _Options) :- !,
	gen_bundle_commit_info(Bundle),
	gen_pbundle_common(Bundle, src, [tgz]).
gen_pbundle_hook(tbz, Bundle, _Options) :- !,
	gen_bundle_commit_info(Bundle),
	gen_pbundle_common(Bundle, src, [tbz]).

